// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  File:    sr_objects.asy
//  Author:  Thomas Mueller, University of Stuttgart, VISUS
//
//    Camera model
//
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

import sr_camera;

triple[] boxVerts = { (0.0, 0.0, 0.0),
                      (1.0, 0.0, 0.0),
                      (1.0, 1.0, 0.0),
                      (0.0, 1.0, 0.0),
                      (0.0, 0.0, 1.0),
                      (1.0, 0.0, 1.0),
                      (1.0, 1.0, 1.0),
                      (0.0, 1.0, 1.0) };
triple[] boxFrontVerts = { (0.0,1.0,0.0),
			   (1.0,1.0,0.0),
			   (1.0,1.0,1.0),
 			   (0.0,1.0,1.0) };

int numBoxVerts = boxVerts.length;

int[][] boxEdges = { {0,1}, {1,2}, {2,3}, {3,0},
                     {4,5}, {5,6}, {6,7}, {7,4},
                     {0,4}, {1,5}, {2,6}, {3,7} };

int[][] boxEdgesBlue = { {0,1}, {1,2}, {3,0},
                     {4,5}, {5,6}, {7,4},
                     {0,4}, {1,5} };

int [][] boxFrontEdges = { {0,1}, {1,2}, {2,3}, {3,0} };

int numBoxEdges = boxEdges.length;
int numBoxEdgesBlue = boxEdgesBlue.length;
int numBoxFrontEdges = boxFrontEdges.length;


void drawBox( real[][] MVP ) {
    pair[] p = new pair[8];
    for(int i=0; i<8; ++i) {
        p[i] = map( MVP, boxVerts[i]-(0.5,0.5,0.5) );
    }
    
    for(int i=0; i<numBoxEdges; ++i) {
        draw(p[boxEdges[i][0]]--p[boxEdges[i][1]]);
    }
    /*
    draw(p[0]--p[1]--p[2]--p[3]--cycle);
    draw(p[4]--p[5]--p[6]--p[7]--cycle);
    draw(p[0]--p[4]);
    draw(p[1]--p[5]);
    draw(p[2]--p[6]);
    draw(p[3]--p[7]);
    */
}
void drawBoxBlue( real[][] MVP ) {
    pair[] p = new pair[8];
    for(int i=0; i<8; ++i) {
        p[i] = map( MVP, boxVerts[i]-(0.5,0.5,0.5) );
    }
    
    for(int i=0; i<numBoxEdgesBlue; ++i) {
        draw(p[boxEdgesBlue[i][0]]--p[boxEdgesBlue[i][1]]);
    }

}

void drawBoxFront( real[][] MVP ) {
    pair[] p = new pair[8];
    for(int i=0; i<8; ++i) {
        p[i] = map( MVP, boxFrontVerts[i]-(0.5,0.5,0.5) );
    }
    
    for(int i=0; i<numBoxFrontEdges; ++i) {
        draw(p[boxFrontEdges[i][0]]--p[boxFrontEdges[i][1]]);
    }

}
